Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14733)
@@ -20,5 +20,5 @@
   [PushExpression(StackType.Integer, "INTEGER.=")]
   public class IntegerEqualsExpression : EqualsExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, interpreter.BooleanStack);
     }
@@ -27,5 +27,5 @@
   [PushExpression(StackType.Float, "FLOAT.=")]
   public class FloatEqualsExpression : EqualsExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, interpreter.BooleanStack);
     }
@@ -34,5 +34,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.=")]
   public class BooleanEqualsExpression : EqualsExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, interpreter.BooleanStack);
     }
@@ -41,5 +41,5 @@
   [PushExpression(StackType.Name, "NAME.=")]
   public class NameEqualsExpression : EqualsExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.NameStack, interpreter.BooleanStack);
     }
@@ -48,5 +48,5 @@
   [PushExpression(StackType.Exec, "EXEC.=")]
   public class ExecEqualsExpression : EqualsExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.ExecStack, interpreter.BooleanStack);
     }
@@ -55,5 +55,5 @@
   [PushExpression(StackType.Code, "CODE.=")]
   public class CodeEqualsExpression : EqualsExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.CodeStack, interpreter.BooleanStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14733)
@@ -9,5 +9,5 @@
   using Interpreter;
 
-  public class ExecExpandExpression : StatefullExpression<PushProgram> {
+  public class ExecExpandExpression : StatefulExpression<PushProgram> {
     public static readonly ExecExpandExpression Empty = new ExecExpandExpression();
 
@@ -32,5 +32,5 @@
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       interpreter.ExecStack.Push(this.State.Expressions);
     }
@@ -81,5 +81,5 @@
   [PushExpression(StackType.Exec, "EXEC.IF")]
   public class ExecIfExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if ((interpreter.BooleanStack.Count == 0) || (interpreter.ExecStack.Count < 2)) return;
@@ -98,5 +98,5 @@
   [PushExpression(StackType.Exec, "EXEC.Y")]
   public class ExecYExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if (interpreter.ExecStack.Count == 0 ||
@@ -119,5 +119,5 @@
   [PushExpression(StackType.Exec, "EXEC.K")]
   public class ExecKExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.ExecStack.Count < 2) return;
 
@@ -134,5 +134,5 @@
   [PushExpression(StackType.Exec, "EXEC.S")]
   public class ExecSExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.ExecStack.Count < 3) return;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14733)
@@ -24,5 +24,5 @@
     }
 
-    public abstract void Eval(IPushGpInterpreter interpreter);
+    public abstract void Eval(IPushInterpreter interpreter);
 
     public override string ToString() {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14733)
@@ -65,5 +65,5 @@
     private static Dictionary<string, Func<Expression>> GetStatefullExpressionFactory() {
       var dictionary = new Dictionary<string, Func<Expression>>();
-      var statefullExpressionType = typeof(StatefullExpression<>);
+      var statefullExpressionType = typeof(StatefulExpression<>);
       var expressionTypes = GetExpressionTypes(statefullExpressionType);
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 14733)
@@ -11,5 +11,5 @@
   [PushExpression(StackType.Float, "FLOAT.+")]
   public class FloatAddExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
     }
@@ -21,5 +21,5 @@
   [PushExpression(StackType.Float, "FLOAT.-")]
   public class FloatSubtractExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
     }
@@ -31,5 +31,5 @@
   [PushExpression(StackType.Float, "FLOAT.*")]
   public class FloatMultiplyExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
     }
@@ -42,5 +42,5 @@
   [PushExpression(StackType.Float, "FLOAT./")]
   public class FloatDivideExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
     }
@@ -56,5 +56,5 @@
   [PushExpression(StackType.Float, "FLOAT.%")]
   public class FloatModuloExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
     }
@@ -66,5 +66,5 @@
   [PushExpression(StackType.Float, "FLOAT.MIN")]
   public class FloatMinExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
     }
@@ -76,5 +76,5 @@
   [PushExpression(StackType.Float, "FLOAT.MAX")]
   public class FloatMaxExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
     }
@@ -86,5 +86,5 @@
   [PushExpression(StackType.Float, "FLOAT.<")]
   public class FloatSmallerThanExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
     }
@@ -96,5 +96,5 @@
   [PushExpression(StackType.Float, "FLOAT.>")]
   public class FloatGreaterThanExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
     }
@@ -106,5 +106,5 @@
   [PushExpression(StackType.Float, "FLOAT.SIN")]
   public class FloatSineExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 1, values => Math.Sin(values[0]));
     }
@@ -116,5 +116,5 @@
   [PushExpression(StackType.Float, "FLOAT.COS")]
   public class FloatCosineExpression : PushResultExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, 1, values => Math.Cos(values[0]));
     }
@@ -126,5 +126,5 @@
   [PushExpression(StackType.Float, "FLOAT.FROMBOOLEAN")]
   public class FloatFromBooleanExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.BooleanStack.Count == 0) return;
 
@@ -141,5 +141,5 @@
   [PushExpression(StackType.Float, "FLOAT.FROMINTEGER")]
   public class FloatFromIntegerExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0) return;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 14733)
@@ -17,5 +17,5 @@
   [PushExpression(StackType.Integer, "INTEGER.FLUSH")]
   public class IntegerFlushExpression : FlushExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.IntegerStack);
     }
@@ -24,5 +24,5 @@
   [PushExpression(StackType.Float, "FLOAT.FLUSH")]
   public class FloatFlushExpression : FlushExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.FloatStack);
     }
@@ -31,5 +31,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.FLUSH")]
   public class BooleanFlushExpression : FlushExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.BooleanStack);
     }
@@ -38,5 +38,5 @@
   [PushExpression(StackType.Name, "NAME.FLUSH")]
   public class NameFlushExpression : FlushExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.NameStack);
     }
@@ -45,5 +45,5 @@
   [PushExpression(StackType.Exec, "EXEC.FLUSH")]
   public class ExecFlushExpression : FlushExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.ExecStack);
     }
@@ -52,5 +52,5 @@
   [PushExpression(StackType.Code, "CODE.FLUSH")]
   public class CodeFlushExpression : FlushExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.CodeStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 14733)
@@ -12,5 +12,5 @@
   [PushExpression(StackType.Integer, "INTEGER.+")]
   public class IntegerAddExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
     }
@@ -22,5 +22,5 @@
   [PushExpression(StackType.Integer, "INTEGER.-")]
   public class IntegerSubtractExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
     }
@@ -32,5 +32,5 @@
   [PushExpression(StackType.Integer, "INTEGER.*")]
   public class IntegerMultiplyExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
     }
@@ -43,5 +43,5 @@
   [PushExpression(StackType.Integer, "INTEGER./")]
   public class IntegerDivideExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
     }
@@ -58,5 +58,5 @@
   [PushExpression(StackType.Integer, "INTEGER.%")]
   public class IntegerModuloExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
     }
@@ -68,5 +68,5 @@
   [PushExpression(StackType.Integer, "INTEGER.MIN")]
   public class IntegerMinExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
     }
@@ -78,5 +78,5 @@
   [PushExpression(StackType.Integer, "INTEGER.MAX")]
   public class IntegerMaxExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
     }
@@ -88,5 +88,5 @@
   [PushExpression(StackType.Integer, "INTEGER.<")]
   public class IntegerSmallerThanExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
     }
@@ -98,5 +98,5 @@
   [PushExpression(StackType.Integer, "INTEGER.>")]
   public class IntegerGreaterThanExpression : PushResultExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
     }
@@ -108,5 +108,5 @@
   [PushExpression(StackType.Integer, "INTEGER.FROMBOOLEAN")]
   public class IntegerFromBooleanExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.BooleanStack.Count == 0) return;
 
@@ -123,5 +123,5 @@
   [PushExpression(StackType.Integer, "INTEGER.FROMFLOAT")]
   public class IntegerFromFloatExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.FloatStack.Count == 0) return;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs	(revision 14733)
@@ -32,9 +32,9 @@
   }
 
-  public abstract class LoopExpression : StatefullExpression<LoopState> {
+  public abstract class LoopExpression : StatefulExpression<LoopState> {
     protected LoopExpression() : base(new LoopState()) { }
     protected LoopExpression(LoopState state) : base(state) { }
 
-    protected void Eval(IPushGpInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false) {
+    protected void Eval(IPushInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false) {
       // if not initialized
       if (this.State.Body == null) {
@@ -59,5 +59,5 @@
     protected abstract LoopExpression Clone(LoopState state);
 
-    protected virtual void PushIteration(IPushGpInterpreter interpreter) {
+    protected virtual void PushIteration(IPushInterpreter interpreter) {
       interpreter.IntegerStack.Push(this.State.CurrentIndex);
 
@@ -68,5 +68,5 @@
     }
 
-    protected virtual void PushLastIteration(IPushGpInterpreter interpreter) {
+    protected virtual void PushLastIteration(IPushInterpreter interpreter) {
       interpreter.IntegerStack.Push(this.State.CurrentIndex);
       interpreter.ExecStack.Push(this.State.Body);
@@ -95,7 +95,7 @@
     //}
 
-    protected abstract bool HasInsufficientArguments(IPushGpInterpreter interpreter, IStack<Expression> sourceStack);
+    protected abstract bool HasInsufficientArguments(IPushInterpreter interpreter, IStack<Expression> sourceStack);
 
-    protected abstract LoopState InitState(IPushGpInterpreter interpreter, IStack<Expression> sourceStack);
+    protected abstract LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack);
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 14733)
@@ -5,8 +5,8 @@
   using Interpreter;
 
-  public class NameDefineXExecExpression : StatefullExpression<string> {
+  public class NameDefineXExecExpression : StatefulExpression<string> {
     public NameDefineXExecExpression(string state) : base(state) { }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Expression expression;
       if (!interpreter.IsNameQuoteFlagSet &&
@@ -31,5 +31,5 @@
   [PushExpression(StackType.Name, "NAME.QUOTE")]
   public class NameQuoteExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       interpreter.IsNameQuoteFlagSet = true;
     }
@@ -41,5 +41,5 @@
   [PushExpression(StackType.Name, "NAME.RANDBOUNDNAME")]
   public class NameRandBoundNameExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.CustomExpressions.Count == 0)
         return;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 14733)
@@ -15,5 +15,5 @@
   [PushExpression(StackType.Integer, "INTEGER.POP")]
   public class IntegerPopExpression : PopExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack);
     }
@@ -22,5 +22,5 @@
   [PushExpression(StackType.Float, "FLOAT.POP")]
   public class FloatPopExpression : PopExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack);
     }
@@ -29,5 +29,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.POP")]
   public class BooleanPopExpression : PopExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack);
     }
@@ -36,5 +36,5 @@
   [PushExpression(StackType.Name, "NAME.POP")]
   public class NamePopExpression : PopExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.NameStack);
     }
@@ -43,5 +43,5 @@
   [PushExpression(StackType.Exec, "EXEC.POP")]
   public class ExecPopExpression : PopExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.ExecStack);
     }
@@ -50,5 +50,5 @@
   [PushExpression(StackType.Code, "CODE.POP")]
   public class CodePopExpression : PopExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.CodeStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 14733)
@@ -3,5 +3,5 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
-  public abstract class PushExpression<T> : StatefullExpression<T> {
+  public abstract class PushExpression<T> : StatefulExpression<T> {
 
     protected PushExpression(T state) : base(state) { }
@@ -18,5 +18,5 @@
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack);
     }
@@ -28,5 +28,5 @@
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack);
     }
@@ -38,5 +38,5 @@
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack);
     }
@@ -48,5 +48,5 @@
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.NameStack);
     }
@@ -58,5 +58,5 @@
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.ExecStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14733)
@@ -10,5 +10,5 @@
   [PushExpression(StackType.Name, "NAME.RAND")]
   public class NameRandExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       var name = NameGenerator.RandomName(interpreter.Random);
 
@@ -22,5 +22,5 @@
   [PushExpression(StackType.Integer, "INTEGER.RAND")]
   public class IntegerRandExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       var value = interpreter.Random.Next(
           interpreter.Configuration.MinRandomInteger,
@@ -36,5 +36,5 @@
   [PushExpression(StackType.Float, "FLOAT.RAND")]
   public class FloatRandExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       var value = interpreter.Random.NextDouble() * (interpreter.Configuration.MaxRandomFloat - interpreter.Configuration.MinRandomFloat) + interpreter.Configuration.MinRandomFloat;
 
@@ -48,5 +48,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.RAND")]
   public class BooleanRandExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       var value = interpreter.Random.NextDouble() > 0.5;
 
@@ -60,5 +60,5 @@
   [PushExpression(StackType.Code, "CODE.RAND")]
   public class CodeRandExpression : StatelessExpression {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0 ||
           interpreter.IntegerStack.Top < 1) return;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 14733)
@@ -16,5 +16,5 @@
   [PushExpression(StackType.Integer, "INTEGER.ROT")]
   public class IntegerRotateExpression : RotateExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.IntegerStack);
     }
@@ -23,5 +23,5 @@
   [PushExpression(StackType.Float, "FLOAT.ROT")]
   public class FloatRotateExpression : RotateExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.FloatStack);
     }
@@ -30,5 +30,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.ROT")]
   public class BooleanRotateExpression : RotateExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.BooleanStack);
     }
@@ -37,5 +37,5 @@
   [PushExpression(StackType.Name, "NAME.ROT")]
   public class NameRotateExpression : RotateExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.NameStack);
     }
@@ -44,5 +44,5 @@
   [PushExpression(StackType.Exec, "EXEC.ROT")]
   public class ExecRotateExpression : RotateExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.ExecStack);
     }
@@ -51,5 +51,5 @@
   [PushExpression(StackType.Code, "CODE.ROT")]
   public class CodeRotateExpression : RotateExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.CodeStack);
     }
